/*
 Navicat Premium Data Transfer

 Source Server         : ∆E
 Source Server Type    : SQLite
 Source Server Version : 3030001
 Source Schema         : main

 Target Server Type    : SQLite
 Target Server Version : 3030001
 File Encoding         : 65001

 Date: 08/03/2022 09:34:55
*/

PRAGMA foreign_keys = false;

-- ----------------------------
-- Table structure for DebugOrders
-- ----------------------------
DROP TABLE IF EXISTS "DebugOrders";
CREATE TABLE "DebugOrders" (
  "Order" TEXT(32) NOT NULL,
  "DEType" text(8) NOT NULL,
  "DEValue" real NOT NULL,
  "CreateTime" TEXT(16) NOT NULL,
  PRIMARY KEY ("Order")
);

-- ----------------------------
-- Table structure for DebugOrders2
-- ----------------------------
DROP TABLE IF EXISTS "DebugOrders2";
CREATE TABLE "DebugOrders2" (
  "Order" TEXT(32) NOT NULL,
  "DEType" text(8) NOT NULL,
  "DEValue" real NOT NULL,
  "CreateTime" TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY ("Order")
);

-- ----------------------------
-- Table structure for DebugSN
-- ----------------------------
DROP TABLE IF EXISTS "DebugSN";
CREATE TABLE "DebugSN" (
  "Order" TEXT NOT NULL,
  "SerialNumber" TEXT NOT NULL,
  "Line" TEXT NOT NULL,
  "StartTime" TEXT NOT NULL,
  "FinishTime" TEXT NOT NULL,
  "Outcome" TEXT NOT NULL,
  "DEAvgValue" real NOT NULL,
  PRIMARY KEY ("SerialNumber")
);

-- ----------------------------
-- Table structure for DebugDetails
-- ----------------------------
DROP TABLE IF EXISTS "DebugDetails";
CREATE TABLE "DebugDetails" (
  "SerialNumber" TEXT(32) NOT NULL,
  "DebugDetails" TEXT,
  PRIMARY KEY ("SerialNumber")
);

PRAGMA foreign_keys = true;
