/************************************************************************/
/*  Copyright (C), 2016-2020, [IT], Ȩ;
/*  ģ  ;
/*      ;
/*
/*      [V];	
/*      ߣ[IT];
/*      ڣ[10/21/2016];
/*
/*
/*  ע    ⣺;
/*
/*  ޸ļ¼[IT];
/*  ޸ڣ;
/*  ޸İ汾;
/*  ޸ݣ;
/************************************************************************/
#ifndef __LIST_SORT_CTRL__
#define __LIST_SORT_CTRL__
#pragma once

// CListSortCtrl
#include "SortHeaderCtrl.h"

#ifdef _DEBUG
#define ASSERT_VALID_STRING( str ) ASSERT( !IsBadStringPtr( str, 0xfffff ) )
#else	//	_DEBUG
#define ASSERT_VALID_STRING( str ) ( (void)0 )
#endif	//	_DEBUG

class CListSortCtrl : public CListCtrl
{
	DECLARE_DYNAMIC(CListSortCtrl)

public:
	CListSortCtrl();
	virtual ~CListSortCtrl();

protected:
	DECLARE_MESSAGE_MAP()
	virtual void PreSubclassWindow();

public:
	// ;
	CArray<CStringArray, CStringArray> m_AryList;
	// Ƿ֧;
	BOOL		m_bSortSupport;
	// б;
	CFont		m_cfont;
	LOGFONT		m_logfont;
	// ǳɫ;
	COLORREF	m_clrLightGrid;
	// ɫ;
	COLORREF	m_clrDarkGrid;
	// ;
	static INT	m_nCompareColumn;
	// ;
	static BOOL	m_bSortAscending;
	// бͷؼ;
	CSortHeaderCtrl	m_Ctrlheader;

	// listϢ;
	BOOL SetHeadings( IN LPCTSTR pszText, ... );
	// ;
	void SetListFont(IN CString strFontName, IN int nFontSize, IN BOOL bBold = FALSE, IN BOOL bItalic =  FALSE);

	static bool IsNumber( LPCTSTR pszText );
	static int NumberCompare( LPCTSTR pszNumber1, LPCTSTR pszNumber2 );
	static bool IsDate( LPCTSTR pszText );
	static int DateCompare( const CString& strDate1, const CString& strDate2 );
	static int __cdecl CompareByLabel( const void *elem1, const void *elem2);
private:
	// бע;
	CString		m_strSection;
	// ;
	INT			m_nNumColumns;
	// Ҫ;
	INT			m_nSortColumns;

protected:
	// ѡ;
	void SortByCol(IN const INT nColIndex);
	// Ϣ;
	void LoadColumnInfo();
	// Ϣ;
	void SaveColumnInfo();
public:
	void RemoveAll();
	afx_msg void OnLvnColumnclick(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnLvnGetdispinfo(NMHDR *pNMHDR, LRESULT *pResult);
#ifndef __LIST_DRAW__
	afx_msg void OnNMCustomdraw(NMHDR *pNMHDR, LRESULT *pResult);
#endif
	afx_msg void OnDestroy();
};


#endif // __LIST_SORT_CTRL__