#ifndef __MD5__
#define __MD5__

#pragma once
//////////////////////////////////////////////////////////////////////////
// MD5Contextṹ;
typedef struct 
{
	// ״̬ (ABCD);
	UINT32 state[4];     
	// 2λ, modulo 2^64 (lsb first);
	UINT32 count[2];  
	// Ļ;
	UINT8  buffer[64];                        
} MD5_CTX;

class __declspec(dllexport) CMD5
{
public:
	CMD5(void);
	CMD5(IN CONST BYTE* szInput,IN CONST size_t& nInputLen);
	~CMD5(void);

private:
	// md5㷨;
	void MD5Init(IN MD5_CTX* md5ctx);
	void MD5Update(IN MD5_CTX* md5ctx, IN UINT8* Input, IN CONST size_t& InputLen);
	void MD5Transform(IN UINT32 state[4], IN UINT8 block[64] );
	void MD5Final(IN UINT8 digest[16], IN MD5_CTX* md5ctx);

	void Decode(IN UINT32 *output, IN UINT8 *input, IN CONST size_t& len);
	void Encode(IN UINT8 *output, IN UINT32 *input, IN CONST size_t& len);

private:
	// md5װ;
	// md5Ƿɹ;
	BOOL	m_bValidDigest;
	// md5Ľֵ;
	UINT8	m_digest[16];
	// md5ֵתΪ16ַ;
	TCHAR	m_digestStr[33];
	// Ҫַ;
	BYTE*	m_pInputText;
	// Ҫַ;
	size_t  m_nInputLen;
	// md5ת;
	BOOL CalcDigest();

	// ӿ;
public:
	void SetBYTEText(IN CONST BYTE* szInput,IN CONST size_t& nInputLen);
	CONST TCHAR* GetMD5Digest();
};

#endif