#include "StdAfx.h"
#include "PipeService.h"
//#include "MainDlg.h"
#include "Protocol.h"

#define PIPENAME _T("\\\\.\\pipe\\OGCAssist")
// ÿһϲٸ߳(Ϊ޶ȵܣĵ)
#define WORKER_THREADS_PER_PROCESSOR 2
// ͬʱͶݵAccept(Ҫʵʵ)
#define MAX_POST_ACCEPT              2
// ݸWorker̵߳˳ź
#define EXIT_CODE                    NULL


// ͷָ;Դĺ

// ͷָ
#define RELEASE(x)                      {if(x != NULL ){delete x;x=NULL;}}
// ͷž
#define RELEASE_HANDLE(x)               {if(x != NULL && x!=INVALID_HANDLE_VALUE){ CloseHandle(x);x = NULL;}}
// ͷSocket
#define RELEASE_SOCKET(x)               {if(x !=INVALID_SOCKET) { closesocket(x);x=INVALID_SOCKET;}}

OnConnectCallback CIOCPPipe::lpOnConnectCallback = NULL;
OnDisconnectCallback CIOCPPipe::lpOnDisconnectCallback = NULL;
OnReciveCallback CIOCPPipe::lpOnReciveCallback = NULL;
OnGoCallback CIOCPPipe::lpOnGoCallback = NULL;

CIOCPPipe::CIOCPPipe(void)
{
    m_nThreads = 0;
    m_hShutdownEvent = NULL;
    m_hIOCompletionPort = NULL;
    m_phWorkerThreads= NULL;
    m_pMain = NULL;
}

CIOCPPipe::~CIOCPPipe(void)
{
	// ȷԴͷ
	this->Stop();
}

DWORD WINAPI CIOCPPipe::_WorkerThread(LPVOID lpParam)
{    
	THREADPARAMS_WORKER* pParam = (THREADPARAMS_WORKER*)lpParam;
	CIOCPPipe* pIOCPModel = (CIOCPPipe*)pParam->pIOCPModel;
	int nThreadNo = (int)pParam->nThreadNo;

	pIOCPModel->ShowMessage(_T("߳ID: %d."),nThreadNo);

	OVERLAPPED           *pOverlapped = NULL;
	ULONG_PTR            pCompletionKey  = NULL;
	DWORD                dwBytesTransfered = 0;
	PER_PIPE_CONTEXT	 *pPipeContext = NULL;

	// ѭ֪յShutdownϢΪֹ
	while (WAIT_OBJECT_0 != WaitForSingleObject(pIOCPModel->m_hShutdownEvent, 0))
	{
		BOOL bReturn = GetQueuedCompletionStatus(
			pIOCPModel->m_hIOCompletionPort,
			&dwBytesTransfered,
			(PULONG_PTR)&pPipeContext,
			&pOverlapped,
			INFINITE);

        dprintf(_T("IOCPϢ"));

		// յ˳־ֱ˳
		if ( EXIT_CODE==(DWORD)pPipeContext )
		{
			//break;
			dprintf(_T("IOCP: ˳Ϣ"));
            continue;
		}

		// жǷ˴
		if( !bReturn )  
		{  
			DWORD dwErr = GetLastError();

			// ʾһʾϢ
			if( !pIOCPModel->HandleError( pPipeContext, dwErr ) )
			{
				//break;
                continue;
			}

			continue;  
		}  
		else  
		{  	
			// ȡĲ
			PER_IO_CONTEXT* pIoContext = CONTAINING_RECORD(pOverlapped, PER_IO_CONTEXT, m_Overlapped);  

			dprintf(_T("IOCP: ȡĲ=%ld"), pIoContext->m_OpType);
			// жǷпͻ˶Ͽ
			if((0 == dwBytesTransfered) && ( OP_RECV==pIoContext->m_OpType || OP_SEND==pIoContext->m_OpType))  
			{  
				//pIOCPModel->_ShowMessage( _T("ͻ %s:%d Ͽ."),pIoContext->szClientName, pIoContext->dwProcessId );
				if ( lpOnDisconnectCallback )
				{
					lpOnDisconnectCallback(pIoContext);
				}
				// ͷŵӦԴ
				pIOCPModel->RemoveContext( pPipeContext );

 				continue;  
			}  
			else
			{
				switch( pIoContext->m_OpType )  
				{  
				case OP_ACCEPT:
					{
						dprintf(_T("ͻӳɹ"));
						pIOCPModel->DoAccpet( pPipeContext, pIoContext );
					}
					break;
				case OP_RECV:
					{
						dprintf(_T("ͻϢ"));
						pIOCPModel->DoRecv( pPipeContext, pIoContext );
					}
					break;
				case OP_SEND:
					{
						// ͳɹ,˴Ϣ;
						dprintf(_T("Ϣʹͻ"));
					}
					break;
				default:
					// Ӧִе
					dprintf(_T("_WorkThreadе pIoContext->m_OpType 쳣.\n"));
					break;
				}
			}
		}
	}

	TRACE(_T("߳ %d ˳.\n"),nThreadNo);

	// ͷ̲߳
	RELEASE(lpParam);	

	return 0;
}

bool CIOCPPipe::Start()
{
	// ʼ̻߳
	InitializeCriticalSection(&m_csContextList);

	// ϵͳ˳¼֪ͨ
	m_hShutdownEvent = CreateEvent(NULL, TRUE, FALSE, NULL);

	// ʼIOCP
	if (false == InitIOCP())
	{
		ShowMessage(_T("ʼIOCPʧܣ\n"));
		return false;
	}
	else
	{
		ShowMessage(_T("\nIOCPʼ\n."));
	}


	ShowMessage(_T("ϵͳ׼Ⱥ....\n"));

	return true;
}

void CIOCPPipe::Stop()
{
    // رϢ֪ͨ
    SetEvent(m_hShutdownEvent);

    for (int i = 0; i < m_nThreads; i++)
    {
        // ֪ͨеɶ˿ڲ˳
        PostQueuedCompletionStatus(m_hIOCompletionPort, 0, (DWORD)EXIT_CODE, NULL);
    }

    // ȴеĿͻԴ˳
    WaitForMultipleObjects(m_nThreads, m_phWorkerThreads, TRUE, INFINITE);

    // ͻбϢ
    ClearContextList();

    // ͷԴ
    DeInitialize();

    ShowMessage(_T("ֹͣ\n"));
}

bool CIOCPPipe::InitIOCP()
{
	// һɶ˿
	m_hIOCompletionPort = CreateIoCompletionPort(INVALID_HANDLE_VALUE, NULL, 0, 0 );

	if ( NULL == m_hIOCompletionPort)
	{
		ShowMessage(_T("ɶ˿ʧܣ: %d!\n"), WSAGetLastError());
		return false;
	}

	// ݱеĴӦ߳
#ifdef _DEBUG
    m_nThreads = 2;
#else
	m_nThreads = WORKER_THREADS_PER_PROCESSOR * GetNoOfProcessors();
#endif

	// Ϊ̳߳ʼ
	m_phWorkerThreads = new HANDLE[m_nThreads];
	
	// ݼ߳
	DWORD nThreadID;
	for (int i = 0; i < m_nThreads; i++)
	{
		THREADPARAMS_WORKER* pThreadParams = new THREADPARAMS_WORKER;
		pThreadParams->pIOCPModel = this;
		pThreadParams->nThreadNo  = i+1;
		m_phWorkerThreads[i] = ::CreateThread(0, 0, _WorkerThread, (void *)pThreadParams, 0, &nThreadID);
	}

	for ( int i = 0; i < MAX_POST_ACCEPT; i++ )
	{
		PostAccept();
	}
    
	TRACE("  _WorkerThread %d .\n", m_nThreads );

	return true;
}

void CIOCPPipe::DeInitialize()
{
	// ɾͻбĻ
	DeleteCriticalSection(&m_csContextList);

	// رϵͳ˳¼
	RELEASE_HANDLE(m_hShutdownEvent);

	// ͷŹָ߳̾
	for( int i=0;i<m_nThreads;i++ )
	{
		RELEASE_HANDLE(m_phWorkerThreads[i]);
	}
	
	RELEASE(m_phWorkerThreads);

	// رIOCP
	RELEASE_HANDLE(m_hIOCompletionPort);

	ShowMessage(_T("ͷԴ.\n"));
}

bool CIOCPPipe::PostAccept()
{
	PER_PIPE_CONTEXT* pPipeContext = new PER_PIPE_CONTEXT;
    pPipeContext->m_hPipe = CreateNamedPipe(
        PIPENAME,                // pipe name 
        PIPE_ACCESS_DUPLEX |     // read/write access 
        FILE_FLAG_OVERLAPPED,    // overlapped mode 
        PIPE_TYPE_MESSAGE |      // message-type pipe 
        PIPE_READMODE_MESSAGE |  // message-read mode 
        PIPE_WAIT,               // blocking mode 
        PIPE_UNLIMITED_INSTANCES,               // number of instances 
        0,   // output buffer size 
        0,   // input buffer size 
        NMPWAIT_WAIT_FOREVER,     // client time-out 
        NULL);                   // default security attributes

    if ( pPipeContext->m_hPipe == INVALID_HANDLE_VALUE )
	{
		delete pPipeContext;
		return false;
	}

	// 󶨵ɶ˿;
	HANDLE hIOCP = CreateIoCompletionPort((HANDLE)pPipeContext->m_hPipe, m_hIOCompletionPort, (DWORD)pPipeContext, 0);
    if ( hIOCP == NULL )
    {
		delete pPipeContext;
        return false;
    }

	// 첽ȴͻ;
    PER_IO_CONTEXT *pNewIoContext = pPipeContext->GetNewIoContext();
    memset(pNewIoContext, 0, sizeof(PER_IO_CONTEXT));
    pNewIoContext->m_OpType = OP_ACCEPT;
    pNewIoContext->m_PipeAccept = pPipeContext->m_hPipe;
    BOOL bConnect = ConnectNamedPipe(pPipeContext->m_hPipe, (LPOVERLAPPED)pNewIoContext);

	if( bConnect )  
	{// صIOɶ˿,صFase;
        CloseHandle(hIOCP);
		//pPipeContext->RemoveContext(pNewIoContext);
		ShowMessage(_T("AcceptPipeʧܣ: %d"), GetLastError()); 
		dprintf(_T("AcceptPipeʧܣ: %d"), GetLastError()); 
		delete pPipeContext;

		return false;  
	} 

#if 0 // ߳д;
	BOOL fPendingIO = FALSE;
	switch(GetLastError())
	{
		// The overlapped connection in progress.
	case ERROR_IO_PENDING:
		fPendingIO = TRUE;
		break;
		// Client is already connected, so signal an event
	case ERROR_PIPE_CONNECTED:
		break;
		// If an error occurs during the connect operation...
	default:
		break;
	}

	return fPendingIO;
#else

	dprintf(_T("Post Accept <%lp> ɹ"), &pNewIoContext->m_Overlapped); 
	AddToContextList(pPipeContext);

	return true;
#endif
}

bool CIOCPPipe::DoAccpet( PER_PIPE_CONTEXT *pPipeContext, PER_IO_CONTEXT* pIoContext )
{
	if( !PostRecv(pIoContext) )
	{
		return false;
	}

	//dprintf(_T("DoAccpet:%p"), &pIoContext->m_Overlapped);
	//pIoContext->ResetBuffer();//˴ResetBuffer½ʱݿ;
	return PostAccept(); 	
}

bool CIOCPPipe::PostRecv( PER_IO_CONTEXT* pIoContext )
{
	// ʼ
	DWORD dwFlags = 0;
	DWORD dwBytes = 0;
	//WSABUF *p_wbuf   = &pIoContext->chRequest;
	OVERLAPPED *p_ol = &pIoContext->m_Overlapped;

	dprintf(_T("PostRecv:%p"), &pIoContext->m_Overlapped);
	pIoContext->ResetBuffer();
	pIoContext->m_OpType = OP_RECV;

	dprintf(_T("ȴͻϢ"));
	// ʼɺͶWSARecv
	int nBytesRecv = ReadFile( pIoContext->m_PipeAccept, pIoContext->szBuffer, BUFSIZE, &dwBytes, p_ol );

	// ֵ󣬲ҴĴ벢PendingĻǾ˵صʧ
	if ((-1 == nBytesRecv) && (ERROR_IO_PENDING != GetLastError()))
	{
		ShowMessage(_T("ͶݵһWSARecvʧܣ"));
		dprintf(_T("ͶݵһWSARecvʧ"));
		return false;
	}

	return true;
}

bool CIOCPPipe::DoRecv( PER_PIPE_CONTEXT *pPipeContext, PER_IO_CONTEXT* pIoContext )
{
	RecvProcess(pPipeContext, pIoContext);

	// ȻʼͶһWSARecv
	return PostRecv( pIoContext );
}

bool CIOCPPipe::AssociateWithIOCP( PER_IO_CONTEXT* pIoContext )
{
	// ںͿͻͨŵSOCKET󶨵ɶ˿
	
	return true;
}

void CIOCPPipe::AddToContextList( PER_PIPE_CONTEXT* pPipeContext )
{
	EnterCriticalSection(&m_csContextList);

	m_arrayClientContext.Add(pPipeContext);	
	
	LeaveCriticalSection(&m_csContextList);
}

void CIOCPPipe::RemoveContext( PER_PIPE_CONTEXT* pPipeContext )
{
	EnterCriticalSection(&m_csContextList);

	for( int i=0; i<m_arrayClientContext.GetCount(); i++ )
	{
		if( pPipeContext == m_arrayClientContext.GetAt(i) )
		{
			RELEASE( pPipeContext );			
			m_arrayClientContext.RemoveAt(i);			
			break;
		}
	}

	LeaveCriticalSection(&m_csContextList);
}

void CIOCPPipe::ClearContextList()
{
	EnterCriticalSection(&m_csContextList);

	for( int i=0;i<m_arrayClientContext.GetCount();i++ )
	{
		delete m_arrayClientContext.GetAt(i);
	}

	m_arrayClientContext.RemoveAll();

	LeaveCriticalSection(&m_csContextList);
}

int CIOCPPipe::GetNoOfProcessors()
{
	SYSTEM_INFO si;

	GetSystemInfo(&si);

	return si.dwNumberOfProcessors;
}

void CIOCPPipe::ShowMessage(const CString szFormat,...) const
{
	// ݴĲʽַ
	CString   strMessage;
	va_list   arglist;

	// 䳤
	va_start(arglist, szFormat);
	strMessage.FormatV(szFormat,arglist);
	va_end(arglist);
}

void CIOCPPipe::RecvProcess(PER_PIPE_CONTEXT* pPipeContext, PER_IO_CONTEXT* pIoContext)
{
	if ( pIoContext )
	{
		// ݳ;
		pIoContext->m_Overlapped.InternalHigh;
		
		/* 
			PACKAGE pak;
			memcpychRequestpak, pIoContext;ԭΪpakṹСֻDATAHEADER+bufbufܴMSG_INFO
			ԽchRequestڴ渴Ƶpakʱ,Խˡ

			memcpy(&pak, pIoContext->chRequest, pIoContext->m_Overlapped.InternalHigh);
		*/
		DATAHEADER header;
		MSG_INFO msg_info;
		memcpy(&header, pIoContext->szBuffer, sizeof(DATAHEADER));
		memcpy(&msg_info, pIoContext->szBuffer+sizeof(DATAHEADER), sizeof(MSG_INFO));

		dprintf(_T("յͻϢResult=%d, Tpye=%d, Proctocl=%d, Len=%ld, Name=%s, Id=%ld, Data=%s"), 
			msg_info.byResult,
			header.byMsgType, 
			header.byProtocol, 
			header.dwPackageLen, 
			msg_info.szClientName,
			msg_info.dwClientId,
			msg_info.byData
			);

		switch( header.byMsgType )
		{
		case C2S_HIJACK:
			{
				dprintf(_T("յͻϢٳ"));
				GLOBAL::g_procWndInfo.bHijackStatus = msg_info.byResult;
			}
			break;
		case C2S_RESUME:
			{
				dprintf(_T("յͻϢָ"));
				GLOBAL::g_procWndInfo.bHijackStatus = !msg_info.byResult;
			}
			break;
		case C2S_CONNECT:
			{
				dprintf(_T("յͻϢ"));
				GLOBAL::g_procWndInfo.bConnectStatus = msg_info.byResult;
				// ͵һ:ص;
				if ( lpOnConnectCallback )
				{
					lpOnConnectCallback(&header, &msg_info);
				}
			}
			break;
		case C2S_DISCONNECT:
			{
				dprintf(_T("յͻϢϿ"));
				GLOBAL::g_procWndInfo.bConnectStatus = !msg_info.byResult;
				// ͵һ:ص;
				if ( lpOnConnectCallback )
				{
					lpOnConnectCallback(&header, &msg_info);
				}
			}
			break;
		case C2S_CHECKFW:
			{
				dprintf(_T("յͻϢCheckFW"));
			}
			break;
		case C2S_EXCEPTION:
			{
				dprintf(_T("յͻϢ쳣"));
			}
			break;
		case C2S_GO:
			{
				dprintf(_T("յͻϢGo"));
				if ( msg_info.byResult )
				{
					// ִгɹ;
				}
				else
				{
					// ִʧ;
				}

				// ͵һ:ص;
				if ( lpOnGoCallback )
				{
					lpOnGoCallback(&header, &msg_info);
				}
			}
			break;
		case C2S_COMMUNICATION_ERROR:
			{
				dprintf(_T("յͻϢͨŴ"));
			}
			break;
		default:
			break;
		}

		DWORD lpNumberOfBytesWritten = 0;
		TCHAR szMsg[MAX_PATH] = {0};
		_stprintf(szMsg, _T("%ld%ld"), GetCurrentThreadId(), GetTickCount());
#if 0
		// WriteFileʱ,Ҫ첽,صIONUULL;
		BOOL bRet = WriteFile(pIoContext->m_PipeAccept, pIoContext->szBuffer, pIoContext->m_Overlapped.InternalHigh, &lpNumberOfBytesWritten, NULL);
		if ( !bRet )
		{
			dprintf(_T("Ϣʧܣ%s, %ld, %ld"), pIoContext->szBuffer, GetLastError(), GetCurrentThreadId());
		}
#else
		// WriteFileʹصIO,WriteȴReadIO޷ٽһֶ;
		if ( pIoContext->pWriteIoContext == NULL )
		{
			pIoContext->pWriteIoContext = new PER_IO_CONTEXT();
			pIoContext->pWriteIoContext->m_OpType = OP_SEND;
			pIoContext->pWriteIoContext->m_PipeAccept = pIoContext->m_PipeAccept;
		}
		memcpy(pIoContext->pWriteIoContext->szBuffer, pIoContext->szBuffer, pIoContext->m_Overlapped.InternalHigh);
		BOOL bRet = WriteFile(pIoContext->m_PipeAccept, pIoContext->pWriteIoContext->szBuffer, pIoContext->m_Overlapped.InternalHigh, &lpNumberOfBytesWritten, &pIoContext->pWriteIoContext->m_Overlapped);
		if ( !bRet )
		{
			dprintf(_T("Ϣʧܣ%s, %ld, %ld"), pIoContext->szBuffer, GetLastError(), GetCurrentThreadId());
		}
#endif
	}
}

/////////////////////////////////////////////////////////////////////
// жϿͻSocketǷѾϿһЧSocketͶWSARecv쳣
// ʹõķǳsocketݣжsocketõķֵ
// Ϊͻ쳣Ͽ(ͻ˱߰εߵ)ʱ򣬷޷յͻ˶Ͽ֪ͨ

bool CIOCPPipe::HandleError( PER_PIPE_CONTEXT *pPipeContext, const DWORD& dwErr )
{
	// ǳʱˣټȰ  
	if( WAIT_TIMEOUT == dwErr )  
	{  	
		dprintf(_T("HandleError: ʱ"));
		return true;
	}
	// ǿͻ쳣˳
	else if( ERROR_BROKEN_PIPE == dwErr )
	{
		RemoveContext(pPipeContext);
		//ShowMessage( _T("⵽ͻ쳣˳") );
		dprintf(_T("⵽ͻ쳣˳\n\n"));
		return true;
	}

	dprintf(_T("ɶ˿ڲִ߳˳룺%d"),dwErr);
	ShowMessage( _T("ɶ˿ڲִ߳˳룺%d"),dwErr );

	return false;
}

BOOL CIOCPPipe::SendPackage(DATAHEADER &header, MSG_INFO &msg)
{
	// ӿͻб,ҵĿͻ;
	if ( m_arrayClientContext.GetSize() == 0 )
		return FALSE;

	// ǰǵԵͻ;
	PER_PIPE_CONTEXT *pPipe = m_arrayClientContext.GetAt(0);
	if ( pPipe == NULL )
		return FALSE;

	std::string data;
	data.append((char*)&header, sizeof(DATAHEADER));
	//data.append((char*)(MSG_INFO*)pak.buf, sizeof(MSG_INFO));
	data.append((char*)&msg, sizeof(MSG_INFO));
	dprintf(_T("ͻ˷ϢResult=%d, Tpye=%d, Proctocl=%d, Len=%ld, Name=%s, Id=%ld, Data=%s"), 
		msg.byResult,
		header.byMsgType, 
		header.byProtocol, 
		header.dwPackageLen, 
		msg.szClientName,
		msg.dwClientId,
		msg.byData
		);

	// ʹͬģʽ;
	DWORD dwNumberOfBytesWritten = 0;
	BOOL fWrite = WriteFile(pPipe->m_hPipe, data.data(), data.size(), &dwNumberOfBytesWritten, NULL);
	dprintf(_T("SendDataError=%ld, %d\n"), GetLastError(), fWrite);

	return FALSE;
}


